from flask import render_template, Blueprint, flash, request, redirect, flash

from suchwow._models import User
from suchwow.utils.decorators import login_required
from suchwow.utils.helpers import get_session_user


bp = Blueprint("profile", "profile")

@bp.route("/profile/edit", methods=["GET", "POST"])
@login_required
def edit():
    user = User.select().where(User.username == get_session_user()).first()
    if request.method == "POST":
        address = request.form.get("address")
        if len(address) in [97, 108]:
            if user:
                user.address = address
                user.save()
            else:
                User.create(username=get_session_user())
            flash('Wallet address saved!', 'is-success')
            return redirect(request.args.get("redirect", "/"))
        else:
            flash("WTF bro, that's not a valid Wownero address", "is-warning")
            return redirect(request.url)
    return render_template("profile/edit.html", profile=user)
