import pickle
from os import path
from datetime import datetime, timedelta

from flask import session

from suchwow._models import AuditEvent, User
from suchwow import config


def allowed_file(filename):
    return "." in filename and \
           filename.rsplit(".", 1)[1].lower() in config.ALLOWED_EXTENSIONS

def get_current_user():
    u = User.select().where(User.username == get_session_user()).first()
    return u

def audit_event(event):
    e = AuditEvent(user=get_current_user(), action=event)
    e.save()

def get_session_user():
    if "auth" not in session or not session["auth"]:
        return None
    return session["auth"]["preferred_username"].strip()

